package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.bank.bo.QuestionBusinessAddBo;
import com.zhongzheng.modules.bank.bo.QuestionBusinessEditBo;
import com.zhongzheng.modules.bank.bo.QuestionBusinessQueryBo;
import com.zhongzheng.modules.bank.domain.QuestionBusiness;
import com.zhongzheng.modules.bank.mapper.QuestionBusinessMapper;
import com.zhongzheng.modules.bank.service.IQuestionBusinessService;
import com.zhongzheng.modules.bank.vo.QuestionBusinessVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 题目业务层次关系Service业务层处理
 *
 * @author hjl
 * @date 2021-10-25
 */
@Service
public class QuestionBusinessServiceImpl extends ServiceImpl<QuestionBusinessMapper, QuestionBusiness> implements IQuestionBusinessService {

    @Autowired
    private QuestionBusinessMapper questionBusinessMapper;

    @Override
    public QuestionBusinessVo queryById(Long id){
        QuestionBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, QuestionBusinessVo.class);
    }

    @Override
    public List<QuestionBusiness> getListById(QuestionBusinessQueryBo bo) {
        return questionBusinessMapper.getListById(bo);
    }

    @Override
    public List<QuestionBusinessVo> queryList(QuestionBusinessQueryBo bo) {
        LambdaQueryWrapper<QuestionBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getEducationTypeId() != null, QuestionBusiness::getEducationTypeId, bo.getEducationTypeId());
        lqw.eq(bo.getBusinessId() != null, QuestionBusiness::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getProjectId() != null, QuestionBusiness::getProjectId, bo.getProjectId());
        lqw.eq(bo.getSubjectId() != null, QuestionBusiness::getSubjectId, bo.getSubjectId());
        lqw.eq(bo.getMajorId() != null, QuestionBusiness::getMajorId, bo.getMajorId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<QuestionBusinessVo> entity2Vo(Collection<QuestionBusiness> collection) {
        List<QuestionBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, QuestionBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<QuestionBusiness> page = (Page<QuestionBusiness>)collection;
            Page<QuestionBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(QuestionBusinessAddBo bo) {
        QuestionBusiness add = BeanUtil.toBean(bo, QuestionBusiness.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(QuestionBusinessEditBo bo) {
        QuestionBusiness update = BeanUtil.toBean(bo, QuestionBusiness.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(QuestionBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
